image: gradle:latest

variables:
  BUILD_COMMON_REPO_TYPE: 'Job-Token'
  BUILD_COMMON_REPO_TOKEN: ${CI_JOB_TOKEN}
  DOCKER_HOST: "tcp://docker:2375"
  # Instruct Docker not to start over TLS.
  DOCKER_TLS_CERTDIR: ""
  # Improve performance with overlayfs.
  DOCKER_DRIVER: overlay2
  # Docker Hub credentials
  IMAGE_TAG: bot-0.0.1

services:
  - name: docker:dind
    # Explicitly disable tls to avoid docker startup interruption
    command: [ "--tls=false" ]

stages:
  - test
  - build

before_script:
  - chmod +x gradlew  # Add execute permission to gradlew

unit_test:
  stage: test
  script:
    - echo "Running unit tests..."
    - ./gradlew test
  artifacts:
    when: always
    reports:
      junit: build/test-results/test/**/TEST-*.xml

build_image:
  stage: build
  image: docker:20.10.7
  services:
    - docker:20.10.7-dind
  before_script:
    - docker login -u ${REGISTRY_USER} -p ${REGISTRY_PASS}
  script:
    - docker build --build-arg BUILD_COMMON_REPO_TYPE=$BUILD_COMMON_REPO_TYPE --build-arg BUILD_COMMON_REPO_TOKEN=$BUILD_COMMON_REPO_TOKEN -t ${REPOSITORY_NAME}:${IMAGE_TAG} .
    - docker push ${REPOSITORY_NAME}:${IMAGE_TAG}